



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>022医疗项目-模块二：药品目录的导入导出-对XSSF导出excel类进行封装</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">022医疗项目-模块二：药品目录的导入导出-对XSSF导出excel类进行封装</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 10:10:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>资源全部来源于传智播客。</p>
<p>好的架构师写的程序，就算给刚入门的新手看，新手一看就知道怎么去用。所以我们要对XSSF导出excel类进行封装。这是架构师的工作，但我们也要知道。</p>
<p>我们写一个封装类：</p>
<p>这个类单独有自己的main函数。</p>
<p>我们进入main函数一步一步看：</p>
<div>
<pre class="prettyprint linenums">public static void main(String[] args) throws Exception {<br />
        /**            导出文件存放物理路径<br />
         * @param fileWebPath<br />
         *            导出文件web下载路径<br />
         * @param filePrefix<br />
         *            导出文件名的前缀<br />
         * @param flushRows<br />
         *            存放在内存的数据量<br />
         * @param fieldNames<br />
         *            导出文件列标题<br />
         * @param fieldCodes<br />
         *               导出数据对象的字段名称<br />
         * @param flushRows*/<br />
        //导出文件存放的路径，并且是虚拟目录指向的路径<br />
        String filePath = "d:/upload/linshi/";<br />
        //导出文件的前缀<br />
        String filePrefix="ypxx";<br />
        //-1表示关闭自动刷新，手动控制写磁盘的时机，其它数据表示多少数据在内存保存，超过的则写入磁盘<br />
        int flushRows=100;

        //指导导出数据的title<br />
        List&lt;String&gt; fieldNames=new ArrayList&lt;String&gt;();<br />
        fieldNames.add("流水号");<br />
        fieldNames.add("通用名");<br />
        fieldNames.add("价格");

        //告诉导出类数据list中对象的属性，让ExcelExportSXXSSF通过反射获取对象的值<br />
        List&lt;String&gt; fieldCodes=new ArrayList&lt;String&gt;();<br />
        fieldCodes.add("bm");//药品流水号<br />
        fieldCodes.add("mc");//通用名<br />
        fieldCodes.add("price");//价格

        //注意：fieldCodes和fieldNames个数必须相同且属性和title顺序一一对应，这样title和内容才一一对应

        //开始导出，执行一些workbook及sheet等对象的初始创建<br />
        ExcelExportSXXSSF excelExportSXXSSF = ExcelExportSXXSSF.start(filePath, "/upload/", filePrefix, fieldNames, fieldCodes, flushRows);

        //准备导出的数据，将数据存入list，且list中对象的字段名称必须是刚才传入ExcelExportSXXSSF的名称<br />
        List&lt;Ypxx&gt; list = new ArrayList&lt;Ypxx&gt;();

        Ypxx ypxx1 = new Ypxx("001", "青霉素", 5);<br />
        Ypxx ypxx2 = new Ypxx("002", "感冒胶囊", 2.5f);<br />
        list.add(ypxx1);<br />
        list.add(ypxx2);

        //执行导出<br />
        excelExportSXXSSF.writeDatasByObject(list);<br />
        //输出文件，返回下载文件的http地址<br />
        String webpath = excelExportSXXSSF.exportFile();

        System.out.println(webpath);

    }</pre>
</div>
<p>首先，我们看fieldNames和fieldCodes这两个List。fielNames里面存放的是Excel文件的标题，我们设置为&ldquo;流水号&rdquo;&ldquo;通用名&rdquo;&ldquo;价格&rdquo;。而filedCodes存放的是标题对应的数据，这个数据来自于查出来的数据库。</p>
<p>比如说，我们从数据库中查出来一个pojo类是Ypxx.</p>
<p>Ypxx里面有bm,mc,price三个属性。那么我们这个bm的值就要设置在l&ldquo;流水号&rdquo;中，mc就要设置在"通用名&rdquo;中，price就要设置在&ldquo;价格&rdquo;中。</p>
<p>最后形成的效果就是：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/996738/201611/996738-20161122202032050-1768789113.png" /></p>
<p>好，我们接下来看看具体是怎么实现的：</p>
<p>ExcelExportSXXSSF excelExportSXXSSF = ExcelExportSXXSSF.start(filePath, "/upload/", filePrefix, fieldNames, fieldCodes, flushRows);</p>
<p>我们具体看一下start函数里面都做了什么.</p>
<div>
<pre class="prettyprint linenums">    public static ExcelExportSXXSSF start(String filePath, String fileWebPath,String filePrefix,<br />
            List&lt;String&gt; fieldNames,List&lt;String&gt; fieldCodes, int flushRows) throws Exception {<br />
        ExcelExportSXXSSF excelExportSXXSSF = new ExcelExportSXXSSF();<br />
        excelExportSXXSSF.setFilePath(filePath);<br />
        excelExportSXXSSF.setFileWebPath(fileWebPath);<br />
        excelExportSXXSSF.setFilePrefix(filePrefix);<br />
        excelExportSXXSSF.setFieldNames(fieldNames);<br />
        excelExportSXXSSF.setFieldCodes(fieldCodes);<br />
        excelExportSXXSSF.setWb(new SXSSFWorkbook(flushRows));//创建workbook<br />
        excelExportSXXSSF.setSh(excelExportSXXSSF.getWb().createSheet());//创建sheet<br />
        excelExportSXXSSF.writeTitles();<br />
        return excelExportSXXSSF;<br />
    }</pre>
</div>
<p>start里面的writeTitles函数我们来看一下：</p>
<div>
<pre class="prettyprint linenums">    /**<br />
     * 设置导入文件的标题<br />
     * 开始生成导出excel的标题<br />
     * @throws Exception<br />
     */<br />
    private void writeTitles() throws Exception {<br />
        rownum = 0;//第0行<br />
        colnum = fieldNames.size();//根据列标题得出列数<br />
        Row row = sh.createRow(rownum);<br />
        for (int cellnum = 0; cellnum &lt; colnum; cellnum++) {<br />
            Cell cell = row.createCell(cellnum);<br />
            cell.setCellValue(fieldNames.get(cellnum));<br />
        }<br />
    }</pre>
</div>
<p>这个函数的功能是：就是Excel表的标题写好。</p>
<p>就是&ldquo;流水号&rdquo;，&ldquo;通用名&rdquo;，&ldquo;价格&rdquo;。</p>
<p>执行完start之后就去执行</p>
<div>
<pre class="prettyprint linenums">List&lt;Ypxx&gt; list = new ArrayList&lt;Ypxx&gt;();

        Ypxx ypxx1 = new Ypxx("001", "青霉素", 5);<br />
        Ypxx ypxx2 = new Ypxx("002", "感冒胶囊", 2.5f);<br />
        list.add(ypxx1);<br />
        list.add(ypxx2);</pre>
</div>
<p>这些代码就是模仿从数据库中取出数据，填入到excel表格中。</p>
<p>最后执行的是</p>
<p>excelExportSXXSSF.writeDatasByObject(list);这一行是关键所在:</p>
<p>给出具体的实现：</p>
<div>
<pre class="prettyprint linenums">    /**<br />
     * 向导出文件写数据<br />
     *<br />
     * @param datalist<br />
     *            存放Object对象，仅支持单个自定义对象，不支持对象中嵌套自定义对象<br />
     * @return<br />
     */<br />
    public void writeDatasByObject(List datalist) throws Exception {

        for (int j = 0; j &lt; datalist.size(); j++) {<br />
            rownum = rownum + 1;<br />
            Row row = sh.createRow(rownum);<br />
            for (int cellnum = 0; cellnum &lt; fieldCodes.size(); cellnum++) {<br />
                Object owner = datalist.get(j);<br />
                Object value = invokeMethod(owner, fieldCodes.get(cellnum),<br />
                        new Object[] {});<br />
                Cell cell = row.createCell(cellnum);<br />
                cell.setCellValue(value!=null?value.toString():"");<br />
            }

        }

    }</pre>
</div>
<p>第一个for循环就是遍历每一个pojo数据（一个就是一行），第二个for循环就是得到每一个pojo类里面的属性值。这里用的是反射。nvokeMethod。这里的value就是我们的每一个值。我们看一下 Object value = invokeMethod(owner, fieldCodes.get(cellnum)函数。</p>
<div>
<pre class="prettyprint linenums">/**<br />
     * 反射方法，通过get方法获取对象属性<br />
     *<br />
     * @param owner<br />
     * @param fieldname<br />
     * @param args<br />
     * @return<br />
     * @throws Exception<br />
     */<br />
    private Object invokeMethod(Object owner, String fieldname, Object[] args)<br />
            throws Exception {

        String methodName = "get" + fieldname.substring(0, 1).toUpperCase()<br />
                + fieldname.substring(1);<br />
        Class ownerClass = owner.getClass();

        Class[] argsClass = new Class[args.length];

        for (int i = 0, j = args.length; i &lt; j; i++) {<br />
            argsClass[i] = args[i].getClass();<br />
        }

        Method method = ownerClass.getMethod(methodName, argsClass);<br />
        return method.invoke(owner, args);<br />
    }</pre>
</div>
<p>下面给出整个封装类代码：</p>
<p>整体代码：</p>
<div>
<pre class="prettyprint linenums">package yycg.util;

import java.io.FileOutputStream;<br />
import java.lang.reflect.Method;<br />
import java.util.ArrayList;<br />
import java.util.List;

import org.apache.poi.ss.usermodel.Cell;<br />
import org.apache.poi.ss.usermodel.Row;<br />
import org.apache.poi.ss.usermodel.Sheet;<br />
import org.apache.poi.xssf.streaming.SXSSFSheet;<br />
import org.apache.poi.xssf.streaming.SXSSFWorkbook;<br />
/**<br />
 * excel导出的封装类<br />
 * @author miaoruntu<br />
 *<br />
 */<br />
public class ExcelExportSXXSSF {

    // 定义工作表<br />
    private SXSSFWorkbook wb;

    /**<br />
     * 定义工作表中的sheet<br />
     */<br />
    private Sheet sh;

    /**<br />
     * 定义保存在内存中的数量,-1表示手动控制<br />
     */<br />
    private int flushRows;<br />
    /** 导出文件行数 */<br />
    private int rownum;<br />
    /** 导出文件列数 */<br />
    private int colnum;

    /** 导出文件的存放路径 */<br />
    private String filePath;<br />
    /** 下载导出文件的路径 */<br />
    private String fileWebPath;<br />
    /**文件名称前缀*/<br />
    private String filePrefix;<br />
    /**导出文件全路径*/<br />
    private String fileAllPath;<br />
    /** 导出文件列标题 */<br />
    private List&lt;String&gt; fieldNames;<br />
    /**导出文件每列代码，用于反射获取对象属性值*/<br />
    private List&lt;String&gt; fieldCodes;

    private ExcelExportSXXSSF() {

    }

    /**<br />
     * 开始导出方法<br />
     *<br />
     * @param filePath<br />
     *            导出文件存放物理路径<br />
     * @param fileWebPath<br />
     *            导出文件web下载路径<br />
     * @param filePrefix<br />
     *            导出文件名的前缀<br />
     * @param flushRows<br />
     *            存放在内存的数据量<br />
     * @param fieldNames<br />
     *            导出文件列标题<br />
     * @param fieldCodes<br />
     *               导出数据对象的字段名称<br />
     * @param flushRows<br />
     *             写磁盘控制参数<br />
     * @return<br />
     */<br />
    public static ExcelExportSXXSSF start(String filePath, String fileWebPath,String filePrefix,<br />
            List&lt;String&gt; fieldNames,List&lt;String&gt; fieldCodes, int flushRows) throws Exception {<br />
        ExcelExportSXXSSF excelExportSXXSSF = new ExcelExportSXXSSF();<br />
        excelExportSXXSSF.setFilePath(filePath);<br />
        excelExportSXXSSF.setFileWebPath(fileWebPath);<br />
        excelExportSXXSSF.setFilePrefix(filePrefix);<br />
        excelExportSXXSSF.setFieldNames(fieldNames);<br />
        excelExportSXXSSF.setFieldCodes(fieldCodes);<br />
        excelExportSXXSSF.setWb(new SXSSFWorkbook(flushRows));//创建workbook<br />
        excelExportSXXSSF.setSh(excelExportSXXSSF.getWb().createSheet());//创建sheet<br />
        excelExportSXXSSF.writeTitles();<br />
        return excelExportSXXSSF;<br />
    }

    /**<br />
     * 设置导入文件的标题<br />
     * 开始生成导出excel的标题<br />
     * @throws Exception<br />
     */<br />
    private void writeTitles() throws Exception {<br />
        rownum = 0;//第0行<br />
        colnum = fieldNames.size();//根据列标题得出列数<br />
        Row row = sh.createRow(rownum);<br />
        for (int cellnum = 0; cellnum &lt; colnum; cellnum++) {<br />
            Cell cell = row.createCell(cellnum);<br />
            cell.setCellValue(fieldNames.get(cellnum));<br />
        }<br />
    }

    /**<br />
     * 向导出文件写数据<br />
     *<br />
     * @param datalist<br />
     *            存放Object对象，仅支持单个自定义对象，不支持对象中嵌套自定义对象<br />
     * @return<br />
     */<br />
    public void writeDatasByObject(List datalist) throws Exception {

        for (int j = 0; j &lt; datalist.size(); j++) {<br />
            rownum = rownum + 1;<br />
            Row row = sh.createRow(rownum);<br />
            for (int cellnum = 0; cellnum &lt; fieldCodes.size(); cellnum++) {<br />
                Object owner = datalist.get(j);<br />
                Object value = invokeMethod(owner, fieldCodes.get(cellnum),<br />
                        new Object[] {});<br />
                Cell cell = row.createCell(cellnum);<br />
                cell.setCellValue(value!=null?value.toString():"");<br />
            }

        }

    }<br />
    /**<br />
     * 向导出文件写数据<br />
     *<br />
     * @param datalist<br />
     *            存放字符串数组<br />
     * @return<br />
     */<br />
    public void writeDatasByString(List&lt;String&gt; datalist) throws Exception {<br />
            rownum = rownum + 1;<br />
            Row row = sh.createRow(rownum);<br />
            int datalist_size = datalist.size();<br />
            for (int cellnum = 0; cellnum &lt; colnum; cellnum++) {<br />
                Cell cell = row.createCell(cellnum);<br />
                if(datalist_size&gt;cellnum){<br />
                    cell.setCellValue(datalist.get(cellnum));<br />
                }else{<br />
                    cell.setCellValue("");<br />
                }

            }<br />
    }

    /**<br />
     * 手动刷新方法,如果flushRows为-1则需要使用此方法手动刷新内存<br />
     *<br />
     * @param flushRows<br />
     * @throws Exception<br />
     */<br />
    public void flush(int flushNum) throws Exception {<br />
        ((SXSSFSheet) sh).flushRows(flushNum);<br />
    }

    /**<br />
     * 导出文件<br />
     *<br />
     * @throws Exception<br />
     */<br />
    public String exportFile() throws Exception {<br />
        String filename = filePrefix+"_"+MyUtil.getCurrentTimeStr() + ".xlsx";<br />
        FileOutputStream out = new FileOutputStream(filePath + filename);<br />
        wb.write(out);<br />
        out.flush();<br />
        out.close();<br />
        setFileAllPath(fileWebPath + filename);<br />
        return fileWebPath + filename;<br />
    }

    /**<br />
     * 反射方法，通过get方法获取对象属性<br />
     *<br />
     * @param owner<br />
     * @param fieldname<br />
     * @param args<br />
     * @return<br />
     * @throws Exception<br />
     */<br />
    private Object invokeMethod(Object owner, String fieldname, Object[] args)<br />
            throws Exception {

        String methodName = "get" + fieldname.substring(0, 1).toUpperCase()<br />
                + fieldname.substring(1);<br />
        Class ownerClass = owner.getClass();

        Class[] argsClass = new Class[args.length];

        for (int i = 0, j = args.length; i &lt; j; i++) {<br />
            argsClass[i] = args[i].getClass();<br />
        }

        Method method = ownerClass.getMethod(methodName, argsClass);<br />
        return method.invoke(owner, args);<br />
    }

    public SXSSFWorkbook getWb() {<br />
        return wb;<br />
    }

    public void setWb(SXSSFWorkbook wb) {<br />
        this.wb = wb;<br />
    }

    public Sheet getSh() {<br />
        return sh;<br />
    }

    public void setSh(Sheet sh) {<br />
        this.sh = sh;<br />
    }

    public int getFlushRows() {<br />
        return flushRows;<br />
    }

    public void setFlushRows(int flushRows) {<br />
        this.flushRows = flushRows;<br />
    }

    public String getFilePath() {<br />
        return filePath;<br />
    }

    public void setFilePath(String filePath) {<br />
        this.filePath = filePath;<br />
    }

    public String getFileWebPath() {<br />
        return fileWebPath;<br />
    }

    public void setFileWebPath(String fileWebPath) {<br />
        this.fileWebPath = fileWebPath;<br />
    }

    public List&lt;String&gt; getFieldNames() {<br />
        return fieldNames;<br />
    }

    public void setFieldNames(List&lt;String&gt; fieldNames) {<br />
        this.fieldNames = fieldNames;<br />
    }

    public List&lt;String&gt; getFieldCodes() {<br />
        return fieldCodes;<br />
    }

    public void setFieldCodes(List&lt;String&gt; fieldCodes) {<br />
        this.fieldCodes = fieldCodes;<br />
    }

    public int getRownum() {<br />
        return rownum;<br />
    }

    public String getFilePrefix() {<br />
        return filePrefix;<br />
    }

    public void setFilePrefix(String filePrefix) {<br />
        this.filePrefix = filePrefix;<br />
    }

    public int getColnum() {<br />
        return colnum;<br />
    }

    public String getFileAllPath() {<br />
        return fileAllPath;<br />
    }

    public void setFileAllPath(String fileAllPath) {<br />
        this.fileAllPath = fileAllPath;<br />
    }

    public static void main(String[] args) throws Exception {<br />
        /**            导出文件存放物理路径<br />
         * @param fileWebPath<br />
         *            导出文件web下载路径<br />
         * @param filePrefix<br />
         *            导出文件名的前缀<br />
         * @param flushRows<br />
         *            存放在内存的数据量<br />
         * @param fieldNames<br />
         *            导出文件列标题<br />
         * @param fieldCodes<br />
         *               导出数据对象的字段名称<br />
         * @param flushRows*/<br />
        //导出文件存放的路径，并且是虚拟目录指向的路径<br />
        String filePath = "d:/upload/linshi/";<br />
        //导出文件的前缀<br />
        String filePrefix="ypxx";<br />
        //-1表示关闭自动刷新，手动控制写磁盘的时机，其它数据表示多少数据在内存保存，超过的则写入磁盘<br />
        int flushRows=100;

        //指导导出数据的title<br />
        List&lt;String&gt; fieldNames=new ArrayList&lt;String&gt;();<br />
        fieldNames.add("流水号");<br />
        fieldNames.add("通用名");<br />
        fieldNames.add("价格");

        //告诉导出类数据list中对象的属性，让ExcelExportSXXSSF通过反射获取对象的值<br />
        List&lt;String&gt; fieldCodes=new ArrayList&lt;String&gt;();<br />
        fieldCodes.add("bm");//药品流水号<br />
        fieldCodes.add("mc");//通用名<br />
        fieldCodes.add("price");//价格

        //注意：fieldCodes和fieldNames个数必须相同且属性和title顺序一一对应，这样title和内容才一一对应

        //开始导出，执行一些workbook及sheet等对象的初始创建<br />
        ExcelExportSXXSSF excelExportSXXSSF = ExcelExportSXXSSF.start(filePath, "/upload/", filePrefix, fieldNames, fieldCodes, flushRows);

        //准备导出的数据，将数据存入list，且list中对象的字段名称必须是刚才传入ExcelExportSXXSSF的名称<br />
        List&lt;Ypxx&gt; list = new ArrayList&lt;Ypxx&gt;();

        Ypxx ypxx1 = new Ypxx("001", "青霉素", 5);<br />
        Ypxx ypxx2 = new Ypxx("002", "感冒胶囊", 2.5f);<br />
        list.add(ypxx1);<br />
        list.add(ypxx2);

        //执行导出<br />
        excelExportSXXSSF.writeDatasByObject(list);<br />
        //输出文件，返回下载文件的http地址<br />
        String webpath = excelExportSXXSSF.exportFile();

        System.out.println(webpath);

    }

}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwd50l8.html">Linux paste命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnwn33q.html">《JavaScript高级程序设计》学习笔记&lpar;4&rpar;&mdash;&mdash;引用类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e7gpm9.html">MySQL 利用SQL线程对Binlog操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/r935vxzq.html">《C&num;高级编程》学习笔记------C&num;中的委托和事件&lpar;续&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ygnlnq.html">一个容易被忽略的ReportingService超时问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1157r9.html">Android Fragment分页显示的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdd7od8.html">在linux&lpar;CentOS-6&period;7&lowbar;x86&lowbar;64&rpar;上安装mysql成功记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xgmgz8.html">C&num;语法杂谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jvlr9.html">onNewIntent调用时机</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z2g709.html">Linux C &mdash;&mdash; 多线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06m1lq.html">Web资源文件的加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okpyyx9.html">Windows Server 2008中关闭事件跟踪程序的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xez5w9.html">&percnt;hd &percnt;d &percnt;ld &percnt;u &period;&period;&period;&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yno3z8.html">关于最优化读写，测试各个加锁：Lock、安全字典、信号量、ReaderWriterLock、ReaderWriterLockSlim</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geyege8.html">SPOJ - DISUBSTR 多少个不同的子串</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxr7o8.html">log4xx&sol;log4j异步日志配置示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1yzdoq.html">计算机17-3&comma;4作业F</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjj5769.html">大叔学ML第四：线性回归正则化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rvoo68.html">executequery要求已打开且可用的connection，连接的当前状态为已关闭</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4rvkk9.html">JavaScript使用浏览器内置XML解析器解析DOM对象</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8kxrn6q.html">Office版本问题0x80029C4A</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw3zyk9.html">Android Studio 插件的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8om2xpq.html">&lbrack;leetcode&rsqb; Bitwise AND of Numbers Range</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2pv0v8.html">iOS仿京东分类菜单实例实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2pv3v8.html">Static Cell-静态TableView</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq11nl5q.html">在xib中添加手势控件后运行可能会出现的错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyzn1g9.html">C&plus;&plus;语言-02-函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2p1jx8.html">android EditView ime</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql6036q.html">&lbrack;Weblogic&rsqb;如何清理缓存</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ezkzj8.html">linux crontab &amp;amp&semi; 每隔10秒执行一次</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
